var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { getCurrentInstance, inject, isVue2 } from 'vue-demi';
import { isArray, isPlainObject, isFunction, isUndef } from '@ace-util/core';
import { getLocation, compilePathRegex } from './utils/path';
import { debug } from './env';
/**
 * activeLoader must be called to handle SSR at the top of functions like
 * `fetch`, `setup`, `serverPrefetch` and others
 */
var activeLoader;
/**
 * Global options
 */
var loaderOptions = {
    sync: false,
};
/**
 * Global error handlers
 */
var errorHandlers = [];
/**
 * inject key
 */
export var ModuleLoaderSymbol = debug
    ? Symbol.for('__VUE_ASYNC_MODULE_LOADER__')
    : Symbol();
/**
 * Set or unset active fetch, Used in SSR and internally when calling
 * actions and getters
 * @param loader ModuleLoader instance
 */
export var setActiveLoader = function (loader) { return (activeLoader = loader); };
/**
 * Get the currently active fetch if there is any.
 */
export var getActiveLoader = function () { return (getCurrentInstance() && inject(ModuleLoaderSymbol)) || activeLoader; };
/**
 * Set ModuleLoader options
 * @param options Options
 */
export function setOptions(options) {
    Object.assign(loaderOptions, options);
}
/**
 * Add global error handler
 * @param handler Error handler
 */
export function addErrorHandler(handler) {
    errorHandlers.push(handler);
}
/**
 * Remove global error handler
 * @param handler Error handler
 */
export function removeErrorHandler(handler) {
    var index = -1;
    if ((index = errorHandlers.findIndex(function (h) { return h === handler; })) >= 0) {
        errorHandlers.splice(index, 1);
    }
}
/**
 * Register sub modules
 * @param config module config
 * @param lifecycles lifecycle
 */
export function registerSubModules(config, lifecycles) {
    var subModuleConfigs = [], innerLifecycles = {};
    if (lifecycles) {
        var keys = Object.keys(lifecycles);
        keys.forEach(function (name) {
            var _b;
            name = name;
            var lifecycleFns = lifecycles[name];
            if (lifecycleFns) {
                if (!innerLifecycles[name]) {
                    innerLifecycles[name] = [];
                }
                (_b = innerLifecycles[name]).push.apply(_b, __spreadArray([], __read((isArray(lifecycleFns) ? lifecycleFns : [lifecycleFns])), false));
            }
        });
    }
    formatModules(config).map(function (config) {
        var activeRule = undefined;
        if (!isFunction(config)) {
            // merge global props
            if (!isUndef(loaderOptions.props)) {
                var globalProps = typeof loaderOptions.props === 'function' ? loaderOptions.props() : loaderOptions.props;
                config.props = __assign(__assign({}, globalProps), config.props);
            }
            // format activeRule
            if (!isUndef(config.activeRule)) {
                var activeRules = isArray(config.activeRule) ? config.activeRule : [config.activeRule];
                activeRule = activeRules.map(function (rule) {
                    if (isFunction(rule)) {
                        return rule;
                    }
                    else {
                        return function (location) {
                            var path = getLocation(location);
                            var regex = compilePathRegex(rule, {});
                            return !!path.match(regex);
                        };
                    }
                });
            }
        }
        subModuleConfigs.push({ config: config, lifecycles: innerLifecycles, activeRule: activeRule, activated: false });
    });
    function useLoader(loader) {
        var currentInstance = getCurrentInstance();
        loader = loader || (currentInstance && inject(ModuleLoaderSymbol)) || undefined;
        if (loader)
            setActiveLoader(loader);
        if (debug && !activeLoader) {
            throw new Error("getActiveLoader was called with no active loader. Did you forget to install loader?\n" +
                "\tconst moduleLoader = createLoader()\n" +
                (isVue2 ? "\tVue.use(ModuleLoaderVuePlugin)\nnew Vue({ moduleLoader })\n" : "\tapp.use(moduleLoader)\n") +
                "This will fail in production.");
        }
        loader = activeLoader;
        return {
            /**
             * Start module loader
             */
            start: function (options) {
                return execute(loader._moduleLoader, subModuleConfigs, Object.assign({}, loaderOptions, options), loader._a);
            },
        };
        /**
         * 执行模块加载
         * @param moduleLoader module loader
         * @param subModuleConfigs module configs
         * @param router vue-router
         * @param app vue instance
         */
        function execute(moduleLoader, subModuleConfigs, options, app) {
            return __awaiter(this, void 0, void 0, function () {
                var loader, unloader, originalUnmount_1, popStateHandler, beforeUnloadListener;
                var _this = this;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            loader = function (needAcivateSubModules) { return __awaiter(_this, void 0, void 0, function () {
                                var stopLoading;
                                var _b;
                                return __generator(this, function (_c) {
                                    switch (_c.label) {
                                        case 0:
                                            stopLoading = (_b = options.loading) === null || _b === void 0 ? void 0 : _b.call(options, 'mount');
                                            // 执行已经加载的模块 mount
                                            return [4 /*yield*/, Promise.all(needAcivateSubModules.map(function (module) { var _b; return (_b = module.mount) === null || _b === void 0 ? void 0 : _b.call(module); }))];
                                        case 1:
                                            // 执行已经加载的模块 mount
                                            _c.sent();
                                            // 执行未加载的模块
                                            return [4 /*yield*/, moduleLoader(needAcivateSubModules.filter(function (module) { return !module.mount; }), {
                                                    sync: options.sync,
                                                    register: options.register,
                                                    errorHandlers: errorHandlers,
                                                })];
                                        case 2:
                                            // 执行未加载的模块
                                            _c.sent();
                                            // hide loading
                                            stopLoading === null || stopLoading === void 0 ? void 0 : stopLoading();
                                            return [2 /*return*/];
                                    }
                                });
                            }); };
                            unloader = function (needUnactivateSubModules) { return __awaiter(_this, void 0, void 0, function () {
                                var stopLoading;
                                var _b;
                                return __generator(this, function (_c) {
                                    switch (_c.label) {
                                        case 0:
                                            stopLoading = (_b = options.loading) === null || _b === void 0 ? void 0 : _b.call(options, 'unmount');
                                            // 执行模块 unmount
                                            return [4 /*yield*/, Promise.all(needUnactivateSubModules.map(function (module) { var _b; return (_b = module.unmount) === null || _b === void 0 ? void 0 : _b.call(module); }))];
                                        case 1:
                                            // 执行模块 unmount
                                            _c.sent();
                                            // hide loading
                                            stopLoading === null || stopLoading === void 0 ? void 0 : stopLoading();
                                            return [2 /*return*/];
                                    }
                                });
                            }); };
                            // 加载未设置 activeRule 的模块
                            return [4 /*yield*/, loader(subModuleConfigs.filter(function (_b) {
                                    var activeRule = _b.activeRule;
                                    return !activeRule;
                                }))];
                        case 1:
                            // 加载未设置 activeRule 的模块
                            _b.sent();
                            if (app) {
                                originalUnmount_1 = app.unmount;
                                // 卸载未设置 activeRule 的模块
                                app.unmount = function () {
                                    return __awaiter(this, void 0, void 0, function () {
                                        return __generator(this, function (_b) {
                                            switch (_b.label) {
                                                case 0: return [4 /*yield*/, unloader(subModuleConfigs.filter(function (_b) {
                                                        var activeRule = _b.activeRule;
                                                        return !activeRule;
                                                    }))];
                                                case 1:
                                                    _b.sent();
                                                    originalUnmount_1();
                                                    return [2 /*return*/];
                                            }
                                        });
                                    });
                                };
                            }
                            // 按 activeRule 规则加载模块
                            if (options.router) {
                                // 使用 vue-router
                                options.router.beforeEach(function (to, from, next) { return __awaiter(_this, void 0, void 0, function () {
                                    var needAcivateSubModules;
                                    return __generator(this, function (_b) {
                                        switch (_b.label) {
                                            case 0:
                                                needAcivateSubModules = subModuleConfigs.filter(function (_b) {
                                                    var activeRule = _b.activeRule, activated = _b.activated;
                                                    return activated !== true && activeRule && activeRule.some(function (rule) { return rule(window.location); });
                                                });
                                                if (!needAcivateSubModules.length)
                                                    return [2 /*return*/, next()];
                                                return [4 /*yield*/, loader(needAcivateSubModules)];
                                            case 1:
                                                _b.sent();
                                                next();
                                                return [2 /*return*/];
                                        }
                                    });
                                }); });
                                options.router.afterEach(function (to, from) { return __awaiter(_this, void 0, void 0, function () {
                                    var needUnactivateSubModules;
                                    return __generator(this, function (_b) {
                                        switch (_b.label) {
                                            case 0:
                                                needUnactivateSubModules = subModuleConfigs.filter(function (_b) {
                                                    var activeRule = _b.activeRule, activated = _b.activated, unmount = _b.unmount;
                                                    return activated === true && !!unmount && activeRule && !activeRule.some(function (rule) { return rule(window.location); });
                                                });
                                                if (!needUnactivateSubModules.length)
                                                    return [2 /*return*/];
                                                return [4 /*yield*/, unloader(needUnactivateSubModules)];
                                            case 1:
                                                _b.sent();
                                                return [2 /*return*/];
                                        }
                                    });
                                }); });
                            }
                            else if (window.addEventListener) {
                                popStateHandler = function () { return __awaiter(_this, void 0, void 0, function () {
                                    var needAcivateSubModules;
                                    return __generator(this, function (_b) {
                                        switch (_b.label) {
                                            case 0:
                                                needAcivateSubModules = subModuleConfigs.filter(function (_b) {
                                                    var activeRule = _b.activeRule, activated = _b.activated;
                                                    return activated !== true && activeRule && activeRule.some(function (rule) { return rule(window.location); });
                                                });
                                                return [4 /*yield*/, loader(needAcivateSubModules)];
                                            case 1:
                                                _b.sent();
                                                return [2 /*return*/];
                                        }
                                    });
                                }); };
                                beforeUnloadListener = function () { return __awaiter(_this, void 0, void 0, function () {
                                    var needUnactivateSubModules;
                                    return __generator(this, function (_b) {
                                        switch (_b.label) {
                                            case 0:
                                                needUnactivateSubModules = subModuleConfigs.filter(function (_b) {
                                                    var activeRule = _b.activeRule, activated = _b.activated, unmount = _b.unmount;
                                                    return activated === true && !!unmount && activeRule && !activeRule.some(function (rule) { return rule(window.location); });
                                                });
                                                return [4 /*yield*/, unloader(needUnactivateSubModules)];
                                            case 1:
                                                _b.sent();
                                                return [2 /*return*/];
                                        }
                                    });
                                }); };
                                window.addEventListener('popstate', popStateHandler);
                                window.addEventListener('beforeunload', beforeUnloadListener);
                            }
                            return [2 /*return*/];
                    }
                });
            });
        }
    }
    return useLoader;
}
/**
 * Register components
 * @param config component config
 */
export function registerComponents(config) {
    var _components = new Map();
    function useLoader(loader) {
        var _this = this;
        var currentInstance = getCurrentInstance();
        loader = loader || (currentInstance && inject(ModuleLoaderSymbol)) || undefined;
        if (loader)
            setActiveLoader(loader);
        if (debug && !activeLoader) {
            throw new Error("getActiveLoader was called with no active loader. Did you forget to install loader?\n" +
                "\tconst moduleLoader = createLoader()\n" +
                (isVue2 ? "\tVue.use(ModuleLoaderVuePlugin)\nnew Vue({ moduleLoader })\n" : "\tapp.use(moduleLoader)\n") +
                "This will fail in production.");
        }
        loader = activeLoader;
        var components = Object.keys(config).reduce(function (prev, componentName) {
            prev[componentName] = function () { return __awaiter(_this, void 0, void 0, function () {
                var params;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            params = config[componentName];
                            if (typeof params === 'string') {
                                params = { src: params };
                            }
                            if (!!_components.has(componentName)) return [3 /*break*/, 2];
                            return [4 /*yield*/, loader._componentLoader
                                    .apply(null, [componentName, params.src, params.styles])
                                    .then(function (component) { return _components.set(componentName, component); })];
                        case 1:
                            _b.sent();
                            _b.label = 2;
                        case 2: return [2 /*return*/, _components.get(componentName)];
                    }
                });
            }); };
            return prev;
        }, {});
        return components;
    }
    return useLoader;
}
/**
 * Format module config from user input
 * @param config user input module config
 * @returns start loader
 */
function formatModules(config) {
    if (isArray(config)) {
        return config.reduce(function (prev, curr) { return __spreadArray(__spreadArray([], __read(prev), false), __read(formatModules(curr)), false); }, []);
    }
    else if (isPlainObject(config)) {
        var configObj_1 = config;
        // no lib name, { name: 'module name', entry: 'entry script'}
        if (configObj_1.entry && typeof configObj_1.entry === 'string') {
            var _b = configObj_1, styles = _b.styles, name_1 = _b.name, props = _b.props, rest = __rest(_b, ["styles", "name", "props"]);
            return [
                __assign(__assign({}, rest), { name: name_1, styles: styles ? (!Array.isArray(styles) ? [styles] : styles) : [], props: props }),
            ];
        }
        else {
            //{ 'module name': 'entry script' | {entry: 'entry script'}}
            return Object.keys(configObj_1).map(function (name) {
                var value = configObj_1[name];
                if (typeof value === 'string') {
                    return {
                        name: name,
                        entry: value,
                    };
                }
                else {
                    var styles = value.styles, props = value.props, rest = __rest(value, ["styles", "props"]);
                    return __assign(__assign({}, rest), { name: name, styles: styles ? (!Array.isArray(styles) ? [styles] : styles) : [], props: props });
                }
            });
        }
    }
    else if (isFunction(config)) {
        return [config];
    }
    else {
        var err_1 = new Error("not support \"".concat(typeof config, "\" type module"));
        try {
            errorHandlers.forEach(function (hander) {
                hander(err_1, config);
            });
        }
        catch (_c) { }
        return [];
    }
}
