"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createComponentLoader = void 0;
var warning_1 = __importDefault(require("warning"));
var core_1 = require("@ace-util/core");
var env_1 = require("../env");
var promisify_1 = require("../utils/promisify");
// Types
var vue_demi_1 = require("vue-demi");
/** 验证组件导出是否正确 */
function validateExportComponent(exports) {
    var _export = (exports && exports.default) || exports;
    if ((0, core_1.isPlainObject)(_export)) {
        return (Object.keys(_export).length > 0 &&
            ((0, core_1.hasOwn)(_export, 'template') ||
                (0, core_1.hasOwn)(_export, 'render') || // component definition
                (0, core_1.hasOwn)(_export, 'setup')) // vue3 or @vue/composition-api
        );
    }
    else {
        // @ts-ignore works on Vue 2, fails in Vue 3
        return vue_demi_1.isVue2 ? _export instanceof vue_demi_1.Vue2 : false;
    }
}
/** 获取组件 */
function getComponentFromExport(scriptExports, componentName, global) {
    if (validateExportComponent(scriptExports)) {
        return (scriptExports && scriptExports.default) || scriptExports;
    }
    (0, warning_1.default)(!env_1.debug, "[@vue-async/module-loader] component not found from ".concat(componentName, " entry exports, fallback to get from window['").concat(componentName, "']"));
    // fallback to global variable who named with ${moduleName} while module exports not found
    var globalVariableExports = global[componentName];
    if (validateExportComponent(globalVariableExports)) {
        return (globalVariableExports && globalVariableExports.default) || globalVariableExports;
    }
    throw new Error("[@vue-async/module-loader] You need to export vue component in ".concat(componentName, " entry"));
}
/**
 * create module loader
 * @param resolver resolver
 */
function createComponentLoader(App, resolver) {
    return function loader(componentName, src, styles) {
        return __awaiter(this, void 0, void 0, function () {
            var scriptExports;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!styles) return [3 /*break*/, 2];
                        if (typeof styles === 'string') {
                            styles = [styles];
                        }
                        return [4 /*yield*/, (0, promisify_1.promisify)(resolver.addStyles(styles))];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [4 /*yield*/, (0, promisify_1.promisify)(resolver.execScript(src))];
                    case 3:
                        scriptExports = _a.sent();
                        return [2 /*return*/, getComponentFromExport(scriptExports, componentName, resolver.context)];
                }
            });
        });
    };
}
exports.createComponentLoader = createComponentLoader;
