"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createModuleLoader = void 0;
var warning_1 = __importDefault(require("warning"));
var core_1 = require("@ace-util/core");
var env_1 = require("../env");
var promisify_1 = require("../utils/promisify");
/** 校验子应用导出的 生命周期 对象是否正确 */
function validateExportLifecycle(exports) {
    // export default function(){} 兼容处理
    var _export = (exports && exports.default) || exports;
    if ((0, core_1.isFunction)(_export)) {
        return true;
    }
    else {
        // 生命周期
        var _a = exports !== null && exports !== void 0 ? exports : {}, bootstrap = _a.bootstrap, mount = _a.mount, unmount = _a.unmount;
        return (!bootstrap || (0, core_1.isFunction)(bootstrap)) && (!mount || (0, core_1.isFunction)(mount)) && (!unmount || (0, core_1.isFunction)(unmount));
    }
}
/** 获取生命周期对象 */
function getLifecyclesFromExports(scriptExports, name, global) {
    if (validateExportLifecycle(scriptExports)) {
        var _export = (scriptExports && scriptExports.default) || scriptExports;
        return (0, core_1.isFunction)(_export) ? { bootstrap: _export } : scriptExports;
    }
    (0, warning_1.default)(!env_1.debug, "[@vue-async/module-loader] lifecycle not found from ".concat(name, " entry exports, fallback to get from window['").concat(name, "']"));
    // fallback to global variable who named with ${name} while module exports not found
    var globalVariableExports = global.exports ? global.exports[name] : global[name];
    if (validateExportLifecycle(globalVariableExports)) {
        var _export = (globalVariableExports && globalVariableExports.default) || globalVariableExports;
        return (0, core_1.isFunction)(_export) ? { bootstrap: _export } : globalVariableExports;
    }
    throw new Error("[@vue-async/module-loader] You need to export lifecycle functions in ".concat(name, " entry"));
}
/** 执行生命周期函数 */
function execLifecycle(lifecycles, module) {
    if (lifecycles) {
        if ((0, core_1.isArray)(lifecycles)) {
            return Promise.all(lifecycles.map(function (lifecycle) { return (0, promisify_1.promisify)(lifecycle(module)); }));
        }
        else {
            return (0, promisify_1.promisify)(lifecycles(module));
        }
    }
    return Promise.resolve();
}
/**
 * create module loader
 * @param App instance from 'createApp' in Vue3, Vue constructor in Vue2
 * @param resolver resolver
 */
function createModuleLoader(App, resolver) {
    return function loader(subModules, _a) {
        var _b = _a.sync, sync = _b === void 0 ? false : _b, _c = _a.errorHandlers, errorHandlers = _c === void 0 ? [] : _c, register = _a.register;
        // eslint-disable-next-line @typescript-eslint/no-this-alias
        var _self = this;
        return new Promise(function (resolve) {
            // 按顺序同步执行
            if (sync === true) {
                schedule(0, resolve);
            }
            else {
                Promise.all(subModules.map(exec)).then(function () { return resolve(); });
            }
        });
        function exec(module) {
            return __awaiter(this, void 0, void 0, function () {
                var lifecycles, registerProperties_1, unregister_1, execMount, execUnmount, err_1, _a, name_1, entry, _b, styles_1, _c, props_1, scriptExports, _d, bootstrap, exportMount_1, exportUnmount_1, unregister_2, execMount, execUnmount, err_2;
                var _this = this;
                return __generator(this, function (_e) {
                    switch (_e.label) {
                        case 0:
                            lifecycles = module.lifecycles;
                            if (!(0, core_1.isFunction)(module.config)) return [3 /*break*/, 7];
                            _e.label = 1;
                        case 1:
                            _e.trys.push([1, 5, , 6]);
                            // before load lifycycle
                            return [4 /*yield*/, execLifecycle(lifecycles.beforeLoad, module.config)];
                        case 2:
                            // before load lifycycle
                            _e.sent();
                            return [4 /*yield*/, (0, promisify_1.promisify)(module.config.call(_self, App))];
                        case 3:
                            registerProperties_1 = _e.sent();
                            execMount = function () { return __awaiter(_this, void 0, void 0, function () {
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: 
                                        // before mount lifecycle
                                        return [4 /*yield*/, execLifecycle(lifecycles.beforeMount, module.config)];
                                        case 1:
                                            // before mount lifecycle
                                            _a.sent();
                                            // no mount lifecycle
                                            (0, warning_1.default)(!env_1.debug, 'functional module has no mount lifecycle and only execute once until app unmount!');
                                            // works on exectued functional module result
                                            if (registerProperties_1) {
                                                unregister_1 = register === null || register === void 0 ? void 0 : register(registerProperties_1);
                                            }
                                            // after mount lifecyle
                                            return [4 /*yield*/, execLifecycle(lifecycles.afterMount, module.config)];
                                        case 2:
                                            // after mount lifecyle
                                            _a.sent();
                                            return [2 /*return*/];
                                    }
                                });
                            }); };
                            // exec mount
                            return [4 /*yield*/, execMount()];
                        case 4:
                            // exec mount
                            _e.sent();
                            execUnmount = function () { return __awaiter(_this, void 0, void 0, function () {
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: 
                                        // before unmount lifecycle
                                        return [4 /*yield*/, execLifecycle(lifecycles.beforeUnmount, module.config)];
                                        case 1:
                                            // before unmount lifecycle
                                            _a.sent();
                                            // no unmount lifecycle
                                            (0, warning_1.default)(!env_1.debug, 'functional module has no unmount lifecycle and only execute once until app unmount!');
                                            // unregister function result
                                            unregister_1 === null || unregister_1 === void 0 ? void 0 : unregister_1();
                                            // after unmount lifecycle
                                            return [4 /*yield*/, execLifecycle(lifecycles.afterUnmount, module.config)];
                                        case 2:
                                            // after unmount lifecycle
                                            _a.sent();
                                            return [2 /*return*/];
                                    }
                                });
                            }); };
                            module.mount = execMount;
                            module.unmount = execUnmount;
                            return [3 /*break*/, 6];
                        case 5:
                            err_1 = _e.sent();
                            errorHandlers.forEach(function (handler) {
                                // 异常不阻止当前执行，error 中处理
                                try {
                                    handler(err_1, module.config);
                                }
                                catch (_a) { }
                            });
                            return [3 /*break*/, 6];
                        case 6: return [3 /*break*/, 14];
                        case 7:
                            _a = module.config, name_1 = _a.name, entry = _a.entry, _b = _a.styles, styles_1 = _b === void 0 ? [] : _b, _c = _a.props, props_1 = _c === void 0 ? {} : _c;
                            _e.label = 8;
                        case 8:
                            _e.trys.push([8, 13, , 14]);
                            // before load lifycycle
                            return [4 /*yield*/, execLifecycle(lifecycles.beforeLoad, module.config)];
                        case 9:
                            // before load lifycycle
                            _e.sent();
                            return [4 /*yield*/, (0, promisify_1.promisify)(resolver.execScript(entry))];
                        case 10:
                            scriptExports = _e.sent();
                            _d = getLifecyclesFromExports(scriptExports, name_1, resolver.context), bootstrap = _d.bootstrap, exportMount_1 = _d.mount, exportUnmount_1 = _d.unmount;
                            // bootstrap only exec in the first time
                            return [4 /*yield*/, (0, promisify_1.promisify)(bootstrap === null || bootstrap === void 0 ? void 0 : bootstrap.call(_self, App))];
                        case 11:
                            // bootstrap only exec in the first time
                            _e.sent();
                            execMount = function () { return __awaiter(_this, void 0, void 0, function () {
                                var registerProperties;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: 
                                        // before mount lifecycle
                                        return [4 /*yield*/, execLifecycle(lifecycles.beforeMount, module.config)];
                                        case 1:
                                            // before mount lifecycle
                                            _a.sent();
                                            // add named styles
                                            return [4 /*yield*/, (0, promisify_1.promisify)(resolver.addStyles(styles_1))];
                                        case 2:
                                            // add named styles
                                            _a.sent();
                                            return [4 /*yield*/, (0, promisify_1.promisify)(exportMount_1 === null || exportMount_1 === void 0 ? void 0 : exportMount_1.call(_self, App, props_1))];
                                        case 3:
                                            registerProperties = _a.sent();
                                            // works on exectued mount function result
                                            if (registerProperties) {
                                                unregister_2 = register === null || register === void 0 ? void 0 : register(registerProperties);
                                            }
                                            // set activated
                                            module.activated = true;
                                            // after mount lifecyle
                                            return [4 /*yield*/, execLifecycle(lifecycles.afterMount, module.config)];
                                        case 4:
                                            // after mount lifecyle
                                            _a.sent();
                                            return [2 /*return*/];
                                    }
                                });
                            }); };
                            // exec mount
                            return [4 /*yield*/, execMount()];
                        case 12:
                            // exec mount
                            _e.sent();
                            // set warn "unmount" unsupport
                            (0, warning_1.default)(!exportUnmount_1, 'Vue2 is not support "unmount" lifecycle');
                            execUnmount = function () { return __awaiter(_this, void 0, void 0, function () {
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: 
                                        // before unmount lifecycle
                                        return [4 /*yield*/, execLifecycle(lifecycles.beforeUnmount, module.config)];
                                        case 1:
                                            // before unmount lifecycle
                                            _a.sent();
                                            // remove named styles
                                            return [4 /*yield*/, (0, promisify_1.promisify)(resolver.removeStyles(styles_1))];
                                        case 2:
                                            // remove named styles
                                            _a.sent();
                                            // exec unmount
                                            return [4 /*yield*/, (0, promisify_1.promisify)(exportUnmount_1 === null || exportUnmount_1 === void 0 ? void 0 : exportUnmount_1.call(_self, App, props_1))];
                                        case 3:
                                            // exec unmount
                                            _a.sent();
                                            // unregister function result
                                            unregister_2 === null || unregister_2 === void 0 ? void 0 : unregister_2();
                                            // set unactivated
                                            module.activated = false;
                                            // after unmount lifecycle
                                            return [4 /*yield*/, execLifecycle(lifecycles.afterUnmount, module.config)];
                                        case 4:
                                            // after unmount lifecycle
                                            _a.sent();
                                            return [2 /*return*/];
                                    }
                                });
                            }); };
                            module.mount = execMount;
                            module.unmount = execUnmount;
                            return [3 /*break*/, 14];
                        case 13:
                            err_2 = _e.sent();
                            errorHandlers.forEach(function (handler) {
                                // 异常不阻止当前执行，error 中处理
                                try {
                                    handler(err_2, module.config);
                                }
                                catch (_a) { }
                            });
                            return [3 /*break*/, 14];
                        case 14: return [2 /*return*/];
                    }
                });
            });
        }
        function schedule(index, resolve) {
            if (index < subModules.length) {
                exec(subModules[index]).then(function (unmount) {
                    schedule(index + 1, resolve);
                });
            }
            else {
                resolve();
            }
        }
    };
}
exports.createModuleLoader = createModuleLoader;
