"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createLoader = void 0;
var VueDemi = __importStar(require("vue-demi"));
var moduleLoader_1 = require("./core/moduleLoader");
var componentLoader_1 = require("./core/componentLoader");
var register_1 = require("./register");
var umd_1 = require("./resolvers/umd");
/**
 * create module loader
 * @param options options
 * @param options.resolver remote module resolver, default to umd resolver
 * @param options.container container to append script, default is append to body in client side
 */
function createLoader(options) {
    var _b, _c;
    if (options === void 0) { options = {}; }
    // Set global VueDemi
    if (window && !window.VueDemi) {
        window.VueDemi = VueDemi;
    }
    var _resolver = (_c = (_b = options.resolver) === null || _b === void 0 ? void 0 : _b.call(options, options.container)) !== null && _c !== void 0 ? _c : (0, umd_1.getUmdResolver)(options.container);
    var loader = VueDemi.markRaw({
        install: function (app) {
            // this allows calling registerSubModules() outside of a component setup after
            (0, register_1.setActiveLoader)(loader);
            if (!VueDemi.isVue2) {
                var moduleLoader = (0, moduleLoader_1.createModuleLoader)(app, _resolver);
                var componentLoader = (0, componentLoader_1.createComponentLoader)(app, _resolver);
                loader._a = app;
                loader._moduleLoader = moduleLoader;
                loader._componentLoader = componentLoader;
                app.config.globalProperties.$moduleLoader = loader;
                app.provide(register_1.ModuleLoaderSymbol, loader);
            }
        },
        setOptions: function (options) {
            register_1.setOptions.call(null, options);
            return this;
        },
        addErrorHandler: function (handler) {
            register_1.addErrorHandler.call(null, handler);
            return this;
        },
        removeErrorHandler: function (handler) {
            register_1.removeErrorHandler.call(null, handler);
            return this;
        },
        resolver: Object.freeze(_resolver),
        // it's actually undefined here
        // @ts-expect-error set in install when using Vue 3
        _a: null,
        // @ts-expect-error set in install when using Vue 3
        _moduleLoader: null,
        // @ts-expect-error set in install when using Vue 3
        _componentLoader: null,
    });
    return loader;
}
exports.createLoader = createLoader;
