"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getUmdResolver = void 0;
/**
 * @author Hubert
 * fork from https://github.com/kuitos/import-html-entry/blob/master/src/utils.js
 */
var warning_1 = __importDefault(require("warning"));
var env_1 = require("../env");
var resolver_1 = require("../resolver");
var isIE11 = typeof navigator !== 'undefined' && navigator.userAgent.indexOf('Trident') !== -1;
function shouldSkipProperty(global, p) {
    if (!global.hasOwnProperty(p) || (!isNaN(p) && parseInt(p) < global.length))
        return true;
    if (isIE11) {
        // https://github.com/kuitos/import-html-entry/pull/32，最小化 try 范围
        try {
            return global[p] && global[p].parent === window;
        }
        catch (err) {
            return true;
        }
    }
    else {
        return false;
    }
}
// safari unpredictably lists some new globals first or second in object order
var firstGlobalProp, secondGlobalProp, lastGlobalProp;
function getGlobalProp(global) {
    var cnt = 0;
    var lastProp;
    var hasIframe = false;
    for (var p in global) {
        if (shouldSkipProperty(global, p))
            continue;
        // 遍历 iframe，检查 window 上的属性值是否是 iframe，是则跳过后面的 first 和 second 判断
        for (var i = 0; i < window.frames.length && !hasIframe; i++) {
            var frame = window.frames[i];
            if (frame === global[p]) {
                hasIframe = true;
                break;
            }
        }
        if (!hasIframe && ((cnt === 0 && p !== firstGlobalProp) || (cnt === 1 && p !== secondGlobalProp)))
            return p;
        cnt++;
        lastProp = p;
    }
    if (lastProp !== lastGlobalProp)
        return lastProp;
    return;
}
function noteGlobalProps(global) {
    // alternatively Object.keys(global).pop()
    // but this may be faster (pending benchmarks)
    firstGlobalProp = secondGlobalProp = undefined;
    for (var p in global) {
        if (shouldSkipProperty(global, p))
            continue;
        if (!firstGlobalProp)
            firstGlobalProp = p;
        else if (!secondGlobalProp)
            secondGlobalProp = p;
        lastGlobalProp = p;
    }
    return lastGlobalProp;
}
var scriptsCache = new Map();
var stylesCache = new Map();
function createSandbox() {
    // TODO: load in sandbox
    var global = window;
    return global;
}
exports.getUmdResolver = (0, resolver_1.defineResolver)(function (container) {
    if (container === void 0) { container = function (proxy) { return proxy.document.body; }; }
    var proxy = createSandbox();
    return {
        context: proxy,
        execScript: function (entry) {
            if (scriptsCache.has(entry))
                return Promise.resolve(scriptsCache.get(entry)); // 从 catch 中获取
            var selector = typeof container === 'string' ? proxy.document.querySelector(container) : container(proxy);
            if (!selector) {
                return Promise.reject(new Error("[@vue-async/module-loader] The container to append script is not found."));
            }
            return new Promise(function (resolve, reject) {
                noteGlobalProps(proxy);
                var script = proxy.document.createElement('script');
                script.src = entry;
                script.onload = function () {
                    var propName = getGlobalProp(proxy);
                    var exports = propName ? proxy[propName] || {} : {};
                    scriptsCache.set(entry, exports); // add to catch
                    resolve(exports);
                };
                script.onerror = function (err) {
                    (0, warning_1.default)(!env_1.debug, "[@vue-async/module-loader] script had a problem to create, entry\uFF1A".concat(entry));
                    selector.removeChild(script); // remove script
                    reject(new Error("script load error, error: ".concat(err.toString())));
                };
                selector.appendChild(script);
            });
        },
        addStyles: function (styles) {
            return __awaiter(this, void 0, void 0, function () {
                var selector_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!styles.length) return [3 /*break*/, 2];
                            selector_1 = typeof container === 'string' ? proxy.document.querySelector(container) : container(proxy);
                            if (!selector_1) {
                                return [2 /*return*/, Promise.reject(new Error("[@vue-async/module-loader] The container to append link is not found."))];
                            }
                            return [4 /*yield*/, Promise.all(styles.map(function (href) {
                                    if (stylesCache.has(href))
                                        return Promise.resolve(); // 从 catch 中获取
                                    return new Promise(function (resolve, reject) {
                                        var link = document.createElement('link');
                                        link.rel = 'stylesheet';
                                        link.type = 'text/css';
                                        link.href = href;
                                        link.onload = function () {
                                            stylesCache.set(href, link);
                                            resolve();
                                        };
                                        link.onerror = function (err) {
                                            (0, warning_1.default)(!env_1.debug, "[@vue-async/module-loader] href had a problem to create, href".concat(href));
                                            selector_1.removeChild(link); // remove link
                                            reject(new Error("style load error, error: ".concat(err.toString())));
                                        };
                                        selector_1.appendChild(link);
                                    });
                                }))];
                        case 1:
                            _a.sent();
                            _a.label = 2;
                        case 2: return [2 /*return*/];
                    }
                });
            });
        },
        removeStyles: function (styles) {
            if (styles.length) {
                styles.forEach(function (href) {
                    var link = stylesCache.get(href);
                    link === null || link === void 0 ? void 0 : link.remove();
                });
            }
        },
    };
});
